unit rsvnalog;

{

 VL:
Copyright (C) 2017  . .

         .

}

interface

uses xmlwork,rsv501;

type


 //   
 TRSVFile = class
             IdFile      : ANSIString;    //  -     
             VersProg    : ANSIString;    //  -   
             VersForm    : ANSIString;    //  -   .
             Document501 : TRSV501Document; //      5.01
             constructor Create;
             destructor Destroy;
            private
             procedure AddError (Msg : ANSIString);
             procedure AddWarning (Msg : ANSIString);
            public
             Errors,Warnings  : array of ANSIString;
             procedure Init;
             function Read (XML : TXMLElement; Path : ANSIString) : Boolean;  //    xml-
            end;


implementation

uses SysUtils;

constructor TRSVFile.Create;
begin
 Init;
end;

destructor TRSVFile.Destroy;
begin
 Init;
 inherited Destroy;
end;

procedure TRSVFile.AddError (Msg : ANSIString);
begin
 SetLength (Errors,Length (Errors) + 1);
 Errors [Length (Errors) - 1] := Msg;
end;

procedure TRSVFile.AddWarning (Msg : ANSIString);
begin
 SetLength (Warnings,Length (Warnings) + 1);
 Warnings [Length (Warnings) - 1] := Msg;
end;

procedure TRSVFile.Init;
begin
 IdFile := '';
 VersProg := '';
 VersForm := '';
 if Document501 <> nil then Document501.Free;
 SetLength (Errors,0);
 SetLength (Warnings,0);
end;

function TRSVFile.Read (XML : TXMLElement; Path : ANSIString) : Boolean;
var
 i,j : integer;
begin
 Init;
 if Length (XML.Attrs) = 0 then AddError (Path + ':     .  .')
 else if Length (XML.Child) = 0 then AddError (Path + ':      .  .')
 else begin
       for i := 0 to Length (XML.Attrs) - 1
        do if XML.Attrs [i].Name = '' then IdFile := XML.Attrs [i].Value
        else if XML.Attrs [i].Name = '' then VersProg := XML.Attrs [i].Value
        else if XML.Attrs [i].Name = '' then VersForm := XML.Attrs [i].Value;
       if (VersForm = '5.01')
        then begin
              for i := 0 to Length (XML.Child) - 1
               do if XML.Child [i].Name = ''
                then begin
                      Document501 := TRSV501Document.Create;
                      if not Document501.Read (XML.Child [i],Path + ' -  [' + IntToStr (i + 1) + ']')
                       then begin
                             for j := 0 to Length (Document501.Errors) - 1 do AddError (Document501.Errors [j]);
                            end;
                      if Length (Document501.Warnings) > 0 then for j := 0 to Length (Document501.Warnings) - 1 do AddWarning (Document501.Warnings [j]);
                     end
                 else AddError (Path + ':   - ' + XML.Child [i].Name + '.  .');
             end
        else AddError (Path + ':    - ' + VersForm + '.  .');
      end;
 Result := (Length (Errors) = 0);
end;

end.